// AppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "phd_fft.h"
#include "AppDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define pi 3.1415926535
#define EQUATION eq(t)
#define M2S(e) #e
#define VECT(x, y) sqrt((x)*(x)+(y)*(y))
#define ARG(x, y) atan2(y, x)
// CAppDlg dialog


double eq(double t)
{
/*
	double ds = 0;
	if (sin(t*0.05)>0)
		ds = 1;
	
	// http://www.pronine.ca/rccir.htm
	
	// jednotka casu zodpovedajuca predoslej hodnote uCap0 (v 
	// predoslom diskretnom okamihu)
	double t = 0.001;			// 1 ms
	double C = 4.7e-6;			// 4.7 uF
	double Rcharge = 300;		// 300 Ohm
	double Rdischarge = 20e3;	// 20 kOhm
	
	double uCap = V * ( 1 - exp(-t/R/C) );

*/
	return (sin(t*0.15)+cos(t*0.724)*0.2+sin(t*t/1000)*0.5)*sin(t*0.023);
}


CAppDlg::CAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAppDlg::IDD, pParent)
	, m_strExpression( _T("(sin(t*0.15)+cos(t*0.724)*0.2+sin(t*t/1000)*0.5)*sin(t*0.023)") )
	, m_nSamples(2048)
	, m_strBandwidth(_T(""))
	, m_strSamples(_T(""))
	, m_strWindowLenSamples(_T("256"))
{
	m_nTimer = 0;
	m_nRecomputeTimer = 0;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nScanTimer = 0;
	m_nWindowLength = 256;
}

void CAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CUSTOM1, m_Graph);
	DDX_Text(pDX, IDC_EDIT2, m_strExpression);
	DDX_Text(pDX, IDC_EDIT3, m_nSamples);
	DDX_Control(pDX, IDC_SCROLLBAR1, m_wndScroll);
	DDX_Control(pDX, IDC_CUSTOM2, m_gFourier);
	DDX_CBString(pDX, IDC_COMBO1, m_strBandwidth);
	DDX_Text(pDX, IDC_EDIT1, m_strSamples);
	DDX_Control(pDX, IDC_CUSTOM3, m_gSpectrum);
	DDX_Control(pDX, IDC_COMBO2, m_comWindow);
	DDX_Text(pDX, IDC_EDIT5, m_strWindowLenSamples);
	DDX_Control(pDX, IDC_COMBO3, m_comSpectrumCalc);
}

BEGIN_MESSAGE_MAP(CAppDlg, CDialog)
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_HSCROLL()
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_EDIT5, &CAppDlg::OnWindowSizeChange)
	ON_BN_CLICKED(IDC_BUTTON2, &CAppDlg::OnBnClickedButton2)
	ON_CBN_SELCHANGE(IDC_COMBO2, &CAppDlg::OnWindowFuncChange)
END_MESSAGE_MAP()


// CAppDlg message handlers

BOOL CAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_comWindow.SetCurSel(2);
	m_comSpectrumCalc.SetCurSel(0);
	// TODO: Add extra initialization here
	GenerateSource();
	GenerateWindow();
	GenerateResult();
	m_wndScroll.SetScrollRange(-m_nWindowLength, m_nSamples);

	return TRUE;  // return TRUE  unless you set the focus to a control
}


// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAppDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CAppDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	static int nLastFFT = 0;
	static LONG lTimestamp = 0;

	if ( nLastFFT == nPos )
		return;
	if (nPos == 0)
		return;

	nLastFFT = nPos;

	// TODO: Add your message handler code here and/or call default
	m_Graph.GetSeries(0)->m_nShift = nPos;
	m_Graph.GetSeries(2)->m_nShift = nPos;

	GenerateResult();

	m_Graph.InvalidateRect( NULL, FALSE );
	m_wndScroll.SetScrollPos( nPos, TRUE );
/*
	if ( GetTickCount() - lTimestamp >= 20 )
	{
		lTimestamp = GetTickCount();
		OnTimer(0);
	}
	
	if (m_nTimer)
		KillTimer(m_nTimer);
	m_nTimer = SetTimer(7, 10, NULL);
*/
	OnTimer(0);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CAppDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == 'SCAN')
	{
		DoScan();
		return;
	}
	if (nIDEvent == 9)
	{
		if (m_nRecomputeTimer)
		{
			KillTimer(m_nRecomputeTimer);
			m_nRecomputeTimer = 0;
		}
		GenerateWindow();
		GenerateResult();
		ComputeFourier();
		m_Graph.InvalidateRect( NULL );
		// recompute window
		return;
	}
	if ( m_nTimer )
	{
		KillTimer(m_nTimer);
		m_nTimer = 0;
	}
	ComputeFourier();
	//CDialog::OnTimer(nIDEvent);
}

void CAppDlg::OnWindowSizeChange()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
	BOOL bUpdate = FALSE;
	m_nWindowLength = _ttoi(m_strWindowLenSamples);
	if ( m_nWindowLength > 16 && m_nWindowLength < 4096 )
	{
		bUpdate = TRUE;
	}

	if ( bUpdate )
	{
		if (m_nRecomputeTimer)
			KillTimer(m_nRecomputeTimer);
		m_nRecomputeTimer = SetTimer(9, 100, NULL);
	}
}

void CAppDlg::GenerateSource()
{
	// signal
	m_Graph.GetSeries(1)->m_clrColor = RGB(255, 0, 0);
	m_Graph.GetSeries(1)->m_nWidth = 1;
	CArray <float, float> &arrData = m_Graph.GetSeries(1)->m_arrData;
	arrData.SetSize( m_nSamples );
	for ( int i = 0; i < m_nSamples; i++ )
	{
		float t=(float)i;
		arrData.SetAt( i, (float)(EQUATION) );
	}
	m_Graph.GetSeries(1)->GetRange();
}

class CEvaluator {
public:
	enum {
		UserVarN = 0,
		UserVarI = 1
	};
	double (*pFunc)(void);
	static double fUserI, fUserN;

	CEvaluator()
	{
		pFunc = NULL;
	}

	static double _fxHann(void)	
	{ return 0.5*(1-cos(2*pi*fUserI/(fUserN-1))); }
	static double _fxRectangular(void)  
	{ return 1; }
	static double _fxHamming(void)	
	{ return 0.54 - 0.46*cos(2*pi*fUserI/(fUserN-1)); }
	static double _fxCosine(void)	
	{ return sin(pi*fUserI/(fUserN-1)); }
	static double _fxLanczos(void)	
	{ return sinc(2*fUserI/(fUserN-1)-1); }
	static double _fxTriangular(void)	
	{ return (fUserN/2 - abs(fUserI-(fUserN-1)/2))*2/fUserN; }
	static double sinc(double v)
	{ return (v==0) ? 1.0 : sin(pi*v)/pi/v; }

	void Prepare( CString strExp )
	{
		if (strExp == "Hann")
			pFunc = _fxHann;
		else if (strExp == "Rectangular")
			pFunc = _fxRectangular;
		else if (strExp == "Hamming")
			pFunc = _fxHamming;
		else if (strExp == "Cosine")
			pFunc = _fxCosine;
		else if (strExp == "Lanczos")
			pFunc = _fxLanczos;
		else if (strExp == "Triangular")
			pFunc = _fxTriangular;
		else
		{
			_ASSERT(0);
		}
	}

	void SetUser( int nSlot, double dValue )
	{
		switch ( nSlot )
		{
			case UserVarN: fUserN = dValue; break;
			case UserVarI: fUserI = dValue; break;
			default:
				_ASSERT(0);
		}
	}

	double Calculate()
	{
		_ASSERT( pFunc );
		return pFunc();
	}
};
double CEvaluator::fUserI, CEvaluator::fUserN;

float QuasiPeak( float fMemory, float fSample )
{
	float dChargePerc = 0.3f;		// fast attack 0.9
	float dDischargePerc = 0.1f;	// slow decay 0.1

	fMemory *= 1-dDischargePerc;
	if (fSample > fMemory)
		fMemory = fSample*dChargePerc + fMemory*(1-dChargePerc);

	return fMemory;
}

CString GetComboText( CComboBox& combo )
{
	int nWindowIndex = combo.GetCurSel();
	_ASSERT( nWindowIndex >= 0 );
	CString strExp;
	combo.GetLBText( nWindowIndex, strExp );
	return strExp;
}

void CAppDlg::GenerateWindow()
{
	// obalka
	int nWindowSize = m_nWindowLength;
	m_Graph.GetSeries(0)->m_clrColor = RGB(0, 255, 0);
	m_Graph.GetSeries(0)->m_nStyle = 1;
	CArray <float, float> &arrDataW = m_Graph.GetSeries(0)->m_arrData;
	arrDataW.SetSize( nWindowSize );
	
	CEvaluator eval;
	CString strExp = GetComboText(m_comWindow);
	eval.Prepare( strExp );

	eval.SetUser( CEvaluator::UserVarN, nWindowSize );
	for ( int i = 0; i < nWindowSize; i++ )
	{
		eval.SetUser( CEvaluator::UserVarI, i );
		arrDataW.SetAt( i, (float)eval.Calculate() );
	}
}

void CAppDlg::GenerateResult()
{
	// obalka
	m_Graph.GetSeries(2)->m_clrColor = RGB(0, 0, 180);
	CArray <float, float> &arrDataX = m_Graph.GetSeries(2)->m_arrData;
	arrDataX.SetSize( m_nWindowLength );

	CGraphSeries* pSerSource = m_Graph.GetSeries(1);
	CGraphSeries* pSerWindow = m_Graph.GetSeries(0);
	CGraphSeries* pSerResult = m_Graph.GetSeries(2);

	for ( int i = pSerResult->Min(); i < pSerResult->Max(); i++ )
	{
		pSerResult->Set( i, pSerWindow->Get(i)*pSerSource->Get(i) );
	}
	pSerResult->GetRange( pSerSource );

/*
	CGraphSeries* pSerSource = m_Graph.GetSeries(1);
	//m_Graph.GetSeries(2)->m_fMin = -1.0f;
	//m_Graph.GetSeries(2)->m_fMax = +1.0f;
	for ( int i = 0; i < nWindowSize; i++ )
	{
		arrDataX.SetAt( i, arrDataW[i]*pSerSource->Get(i) );
	}
	m_Graph.GetSeries(2)->GetRange(m_Graph.GetSeries(1));
	*/
}

void CAppDlg::ComputeFourier()
{
	CGraphSeries* pSerResult = m_Graph.GetSeries(2);

	int nExp2;
	int nFFTCount = (int)pSerResult->m_arrData.GetSize();

	if ( nFFTCount <= 16 )
		nExp2 = 16;
	else if ( nFFTCount <= 32 )
		nExp2 = 32;
	else if ( nFFTCount <= 64 )
		nExp2 = 64;
	else if ( nFFTCount <= 128 )
		nExp2 = 128;
	else if ( nFFTCount <= 256 )
		nExp2 = 256;
	else if ( nFFTCount <= 512 )
		nExp2 = 512;
	else if ( nFFTCount <= 1024 )
		nExp2 = 1024;
	else if ( nFFTCount <= 2048 )
		nExp2 = 2048;
	else if ( nFFTCount <= 4096 )
		nExp2 = 4096;
	else {
		_ASSERT(0);
	}

	m_fft.ComplexFFT(
		pSerResult->m_arrData.GetData(), 
		nFFTCount,
		nExp2, 
		1);

	nFFTCount /= 2;

	CGraphSeries* pSerFFT = m_gFourier.GetSeries(1);
	pSerFFT->m_nStyle = 1;
	pSerFFT->m_arrData.SetSize(nFFTCount);
	
	for (int i=0; i<nFFTCount; i++)
		pSerFFT->m_arrData.SetAt(i, 
			VECT(m_fft.vector[i*2], m_fft.vector[i*2+1]));

	pSerFFT->GetRange();

	CGraphSeries* pSerFFTA = m_gFourier.GetSeries(0);
	pSerFFTA->m_clrColor = RGB(128, 128, 128);
	pSerFFTA->m_nStyle = 2;
	pSerFFTA->m_arrData.SetSize(nFFTCount);
	
	for (int i=0; i<nFFTCount; i++)
		pSerFFTA->m_arrData.SetAt(i, 
			ARG(m_fft.vector[i*2], m_fft.vector[i*2+1]));

	pSerFFTA->m_fMin = (float)-pi*2;
	pSerFFTA->m_fMax = (float)+pi*2;

	m_gFourier.InvalidateRect( NULL, FALSE );
}

void CAppDlg::OnBnClickedButton2()
{
	m_Graph.GetSeries(0)->m_nShift = -1;
	m_Graph.GetSeries(2)->m_nShift = -1;

	// Run scan
	if (m_nScanTimer)
		KillTimer(m_nScanTimer);
	m_nScanTimer = SetTimer('SCAN', 200, NULL);
}

void CAppDlg::DoScan()
{
	CGraphSeries *pSerSpectrum = m_gSpectrum.GetSeries(0);
	CGraphSeries *pSerFFT = m_gFourier.GetSeries(1);

	static int nPasses = 0;
	int nShift = m_Graph.GetSeries(0)->m_nShift;
	BOOL bInit = FALSE;
	if (nShift == -1)
	{
		// init, radsej flag...
		nShift = 0;
		bInit = TRUE;
	} else
		nShift += m_Graph.GetSeries(0)->GetWidth()/2;
	
	m_Graph.GetSeries(0)->m_nShift = nShift;
	m_Graph.GetSeries(2)->m_nShift = nShift;

	m_Graph.InvalidateRect( NULL, FALSE );
	GenerateResult();
	ComputeFourier();

	if (bInit)
	{
		nPasses = 0;
		pSerSpectrum->m_fMax = 0;
		pSerSpectrum->m_fMin = 0;
		pSerSpectrum->m_nStyle = 1;
		pSerSpectrum->m_arrData.SetSize(
			pSerFFT->GetWidth() );

		for ( int i=0; i<pSerSpectrum->GetWidth(); i++)
			pSerSpectrum->m_arrData[i] = 0.0f;
	}

	nPasses++;
	CString strMethod = GetComboText( m_comSpectrumCalc );
	if ( strMethod == _T("Average") )
	{
		for ( int i=0; i<pSerSpectrum->GetWidth(); i++)
			pSerSpectrum->m_arrData[i] += pSerFFT->Get(i);
		pSerSpectrum->m_fMax += pSerFFT->m_fMax;
	} else
	if ( strMethod == _T("RMS") )
	{
		for ( int i=0; i<pSerSpectrum->GetWidth(); i++)
		{
			FLOAT fSample = pSerFFT->Get(i);
			pSerSpectrum->m_arrData[i] += fSample*fSample;
		}
		pSerSpectrum->GetRange();
	} else
	if ( strMethod == _T("Peak (MAX)") )
	{
		for ( int i=0; i<pSerSpectrum->GetWidth(); i++)
		{
			FLOAT fSample = pSerFFT->Get(i);
			pSerSpectrum->m_arrData[i] = max(pSerSpectrum->m_arrData[i], fSample);
		}
		pSerSpectrum->GetRange();
	} else
	if ( strMethod == _T("QuasiPeak") )
	{
		for ( int i=0; i<pSerSpectrum->GetWidth(); i++)
		{
			FLOAT fSample = pSerFFT->Get(i);
			pSerSpectrum->m_arrData[i] = QuasiPeak( pSerSpectrum->m_arrData[i], fSample );
		}
		pSerSpectrum->GetRange( pSerFFT );
	} else
	{
		_ASSERT(0);
	}

	m_gSpectrum.InvalidateRect( NULL, FALSE );

	if ( nShift+m_Graph.GetSeries(0)->GetWidth() >= 
		m_Graph.GetSeries(1)->Max() )
	{
		if ( strMethod == _T("RMS") )
		{
			for ( int i=0; i<pSerSpectrum->GetWidth(); i++)
			{
				FLOAT fSample = pSerFFT->Get(i);
				pSerSpectrum->m_arrData[i] = sqrt(pSerSpectrum->m_arrData[i] / nPasses);
			}
			pSerSpectrum->GetRange( pSerFFT );
		}

		KillTimer(m_nScanTimer);
		m_nScanTimer = 0;
		return;
	}
}

void CAppDlg::OnWindowFuncChange()
{
	// TODO: Add your control notification handler code here
	GenerateWindow();
	GenerateResult();
	m_Graph.InvalidateRect( NULL, FALSE );
	ComputeFourier();
}
