#pragma once

// CGraph

class CGraphSeries {
public:
	CGraphSeries()
	{
		m_nShift = 0;
		m_nStyle = 0;
		m_fMin = 0;
		m_fMax = 1;
		m_clrColor = RGB(0, 0, 0);
		m_nWidth = 3;
	}
	float Get(int i)
	{
		i -= m_nShift;
		if ( i >= 0 && i < m_arrData.GetSize() )
			return m_arrData[i];
		return 0;
	}
	void Set(int i, float f)
	{
		i -= m_nShift;
		if ( i >= 0 && i < m_arrData.GetSize() )
			m_arrData[i] = f;
	}
	int Min()
	{
		return +m_nShift;
	}
	int Max()
	{
		return (int) m_arrData.GetSize()+m_nShift;
	}
	int GetWidth()
	{
		return (int)m_arrData.GetSize();
	}
	int m_nShift;
	int m_nStyle;
	int m_nWidth;
	COLORREF m_clrColor;
	FLOAT m_fMin;
	FLOAT m_fMax;
	CArray <float, float> m_arrData;
	void GetRange()
	{
		for ( int i=0; i< m_arrData.GetSize(); i++)
		{
			if (i == 0)
				m_fMin = m_fMax = m_arrData[i];
			m_fMin = min(m_fMin, m_arrData[i]);
			m_fMax = max(m_fMax, m_arrData[i]);
		}
	}
	void GetRange(CGraphSeries* pSer)
	{
		m_fMin = pSer->m_fMin;
		m_fMax = pSer->m_fMax;
	}
};

class CGraph : public CWnd
{
	DECLARE_DYNAMIC(CGraph)
	CArray <CGraphSeries*, CGraphSeries*> m_arrSeries;

	COLORREF m_clrBack;
	int m_nDCWidth;
	int m_nDCHeight;
	CDC m_dcBuffer;
	CBitmap  m_bmpBuffer;
	int m_nTotalWidth;
public:
	CGraph();
	virtual ~CGraph();
	BOOL RegisterWindowClass();

	void Setup(COLORREF clrBack, COLORREF clrLine);


	CPoint GetPoint( int s, int n );
	static COLORREF ColorMid( COLORREF a, COLORREF b, int l );
	static COLORREF ColorDelta( COLORREF clr, int r, int g, int b );
	FLOAT *ComputeFourier();

protected:
	DECLARE_MESSAGE_MAP()
public:
	BOOL m_bSetup;
	afx_msg void OnPaint();
	CGraphSeries* GetSeries( int n );
};


